<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 07/24/2004 *
 * ===================                          Last change: 07/31/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-holiday.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Holiday requests                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Urlaubsschaltungen                               *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addMenuDescription('member', __FILE__);

if ((!isExtensionActive('holiday')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('holiday'));
	return;
} // END - if

// Init content array
$content = array();

// Check for running mail orders in pool
$result1 = SQL_QUERY_ESC("SELECT
	`timestamp`
FROM
	`{?_MYSQL_PREFIX?}_pool`
WHERE
	`sender`=%s
ORDER BY
	`timestamp` DESC
LIMIT 1", array(getMemberId()), __FILE__, __LINE__);

// Check for sent mail orders in stats
$result2 = SQL_QUERY_ESC("SELECT
	`timestamp_ordered`
FROM
	`{?_MYSQL_PREFIX?}_user_stats`
WHERE
	`userid`=%s
ORDER BY
	`timestamp_ordered` DESC
LIMIT 1", array(getMemberId()), __FILE__, __LINE__);

if ((SQL_NUMROWS($result1) == 1) || (SQL_NUMROWS($result2) == 1)) {
	// Mail order found!
	$content = merge_array($content, SQL_FETCHARRAY($result1));
	$content = merge_array($content, SQL_FETCHARRAY($result2));

	// Fix missing entries
	if (empty($content['timestamp'])) $content['timestamp'] = '0';
	if (empty($content['timestamp_ordered'])) $content['timestamp_ordered'] = '0';

	if ((($content['timestamp'] + getConfig('holiday_lock')) > time()) || (($content['timestamp_ordered'] + getConfig('holiday_lock')) > time())) {
		// Mail order is to close away!
		unsetPostRequestElement('ok');
		unsetPostRequestElement('stop');

		if (($content['timestamp'] + getConfig('holiday_lock')) > time()) {
			// Mail found in pool
			$stamp = $content['timestamp'];
		} else {
			// Mail found in stats
			$stamp = $content['timestamp_ordered'];
		}

		// Display message and exit here
		loadTemplate('admin_settings_saved', false, getMaskedMessage('HOLIDAY_MEMBER_ORDER', generateDateTime($stamp, 1)));
		return;
	}
} // END - if

// Free memory
SQL_FREERESULT($result1);
SQL_FREERESULT($result2);

if (isFormSent()) {
	// Check holiday request...
	$START = mktime(0, 0, 0, postRequestElement('start_month'), postRequestElement('start_day'), postRequestElement('start_year'));
	$content['holiday_end']   = mktime(0, 0, 0, postRequestElement('end_month')  , postRequestElement('end_day')  , postRequestElement('end_year')  );

	// Test both values
	$TEST = $content['holiday_end'] - $START;
	if (($TEST < 0) || ($TEST > (getConfig('ONE_DAY') * getConfig('holiday_max'))) || ($START < time()) || ($content['holiday_end'] < time())) {
		// Time test failed
		unsetPostRequestElement('ok');
	} else {
		// Everything went okay so let's store his request and send mails
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_holidays` (`userid`, `holiday_start`, `holiday_end`, `comments`) VALUES ('%s','%s','%s','%s')",
			array(getMemberId(), $START, $content['holiday_end'], postRequestElement('comments')), __FILE__, __LINE__);

		// Activate holiday system
		SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`holiday_active`='N', `holiday_activated`=UNIX_TIMESTAMP()
WHERE
	`userid`=%s
LIMIT 1",
			array(getMemberId()), __FILE__, __LINE__);

		// Prepare constants
		$content['start_day']   = bigintval(postRequestElement('start_day'));
		$content['start_month'] = $GLOBALS['month_descr'][postRequestElement('start_month')];
		$content['start_year']  = bigintval(postRequestElement('start_year'));
		$content['end_day']     = bigintval(postRequestElement('end_day'));
		$content['end_month']   = $GLOBALS['month_descr'][postRequestElement('end_month')];
		$content['end_year']    = bigintval(postRequestElement('end_year'));
		$content['comments']    = secureString(postRequestElement('comments'));

		// Send mail to member
		$message = loadEmailTemplate('member_holiday_request', $content, getMemberId());
		sendEmail(getMemberId(), getMessage('HOLIDAY_MEMBER_SUBJECT'), $message);

		// Send mail to all admins
		sendAdminNotification(getMessage('HOLIDAY_ADMIN_SUBJECT'), 'admin_holiday_request', $content, getMemberId());

		// Create task
		createNewTask('{--HOLIDAY_ADMIN_SUBJECT--}', $message, 'HOLIDAY_REQUEST', getMemberId());

		// Display message
		loadTemplate('admin_settings_saved', false, getMessage('HOLIDAY_IS_ACTIVATED_NOW'));
	}
} // END - if

// Holiday shall be ended now
if (isPostRequestElementSet('stop')) {
	// Okay, end the holiday here...
	$result = SQL_QUERY_ESC("SELECT
	`holiday_active`, `holiday_activated`
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	`userid`=%s
LIMIT 1", array(getMemberId()), __FILE__, __LINE__);
	$content = merge_array($content, SQL_FETCHARRAY($result));
	SQL_FREERESULT($result);

	if (($content['holiday_active'] == 'Y') && (($content['holiday_activated'] + getConfig('holiday_lock')) < time())) {
		// Load data
		$result = SQL_QUERY_ESC("SELECT
	`holiday_start`, `holiday_end`
FROM
	`{?_MYSQL_PREFIX?}_user_holidays`
WHERE
	`userid`=%s
LIMIT 1", array(getMemberId()), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Data was found
			$content = merge_array($content, SQL_FETCHARRAY($result));
			SQL_FREERESULT($result);

			// Prepare it for the template
			$content['start'] = generateDateTime($content['holiday_start'], 3);
			$content['end']   = generateDateTime($content['holiday_end']  , 3);

			// Deactivate it now
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data`
SET
	`holiday_active`='N',
	`holiday_activated`=0
WHERE
	`userid`=%s
LIMIT 1",
				array(getMemberId()), __FILE__, __LINE__);

			// Remove entry
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM
	`{?_MYSQL_PREFIX?}_user_holidays`
WHERE
	`userid`=%s
LIMIT 1",
				array(getMemberId()), __FILE__, __LINE__);

			// Send email to admin
			sendAdminNotification(getMessage('HOLIDAY_ADMIN_DEAC_SUBJ'), 'admin_holiday_deactivated', $content, getMemberId());

			// Display message to user
			loadTemplate('admin_settings_saved', false, getMessage('HOLIDAY_MEMBER_DEACTIVATED_NOW'));
		} else {
			// Display message to user
			loadTemplate('admin_settings_saved', false, getMessage('HOLIDAY_MEMBER_CANNOT_DEACTIVATE'));
		}
	} elseif ($content['holiday_active'] == 'Y') {
		// To fast!
		loadTemplate('admin_settings_saved', false, getMessage('HOLIDAY_MEMBER_LOCKED'));
	}
} // END - if

// If something is wrong or link in menu is just clicked display form
if ((!isFormSent()) && (!isPostRequestElementSet('stop'))) {
	// Check if user is in holiday...
	$result = SQL_QUERY_ESC("SELECT
	`holiday_active`, `holiday_activated`
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	`userid`=%s
LIMIT 1", array(getMemberId()), __FILE__, __LINE__);
	$content = SQL_FETCHARRAY($result);
	SQL_FREERESULT($result);

	// Check for lock
	if (($content['holiday_activated'] + getConfig('holiday_lock')) < time()) {
		// User can deactivate his holiday request
		switch ($content['holiday_active'])
		{
			case 'Y': // Display deactivation form
				// Load starting and ending date
				$result = SQL_QUERY_ESC("SELECT
	`holiday_start`, `holiday_end`
FROM
	`{?_MYSQL_PREFIX?}_user_holidays`
WHERE
	`userid`=%s
LIMIT 1", array(getMemberId()), __FILE__, __LINE__);
				if (SQL_NUMROWS($result) == 1) {
					// Data was found
					$content = merge_array($content, SQL_FETCHARRAY($result));
					SQL_FREERESULT($result);

					// Prepare it for the template
					$content['start'] = generateDateTime($content['holiday_start'] , 3);
					$content['end']   = generateDateTime($content['holiday_end']   , 3);
					$content['lock']  = generateDateTime($content['holiday_activated'], 1);

					// Load template
					loadTemplate('member_holiday_deactivate', false, $content);
				} else {
					// Free memory
					SQL_FREERESULT($result);

					// Remove entry and reload URL
					SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`holiday_active`='N'
WHERE
	`userid`=%s
LIMIT 1", array(getMemberId()), __FILE__, __LINE__);
					redirectToUrl('modules.php?module=login&amp;what=holiday');
					return;
				}
				break;

			case 'N': // Display activation form
				// Starting day
				$content['start_day']   = addSelectionBox('day'  , date('d', (time() + getConfig('ONE_DAY'))), 'start');
				$content['start_month'] = addSelectionBox('month', date('m', (time() + getConfig('ONE_DAY'))), 'start');
				$content['start_year']  = addSelectionBox('year' , date('Y', (time() + getConfig('ONE_DAY'))), 'start');

				// Calcualte ending date
				$D = date('d', time() + getConfig('ONE_DAY') + (getConfig('ONE_DAY') * getConfig('holiday_max')));
				$M = date('m', time() + getConfig('ONE_DAY') + (getConfig('ONE_DAY') * getConfig('holiday_max')));
				$Y = date('Y', time() + getConfig('ONE_DAY') + (getConfig('ONE_DAY') * getConfig('holiday_max')));

				// Ending day
				$content['end_day']   = addSelectionBox('day'  , $D, 'end');
				$content['end_month'] = addSelectionBox('month', $M, 'end');
				$content['end_year']  = addSelectionBox('year' , $Y, 'end');

				// Output form
				loadTemplate('member_holiday_form', false, $content);
				break;
		}
	} else {
		// To fast!
		loadTemplate('admin_settings_saved', false, getMessage('HOLIDAY_MEMBER_LOCKED'));
	}
} // END - if

// [EOF]
?>
